---
updatedAt: 2026-06-22T12:56:20.000Z
agentTools:
  projectIndex: https://docs.accurateappend.com/llms.txt
---

# MaxConnect Email Append

Append verified email addresses to U.S. contact records by searching our database of more than 1.8 billion listings using existing contact fields such as first name, last name, city, state, and postal address.

## Making a Request

The AppendEmail method leverages the same low level search functions and data sources used in our Batch Email Append service. Pass your existing contact information such as first name, last name, city, state, and physical address to look-up the email address(es) associated with your customer.

## Postal Address Input and Parsing

All postal address input is automatically parsed and corrected using our address standardization app. This ensures the highest possible match rate and reduces matching issues. The endpoint requires a street address and city/state/postal code or city/state or postal code.

## Output Email Address Verification

All output email addresses are verified in real-time by pinging the ISP to determine deliverability status with 90% accuracy. Output email addresses are also scanned by a real-time SPAM detection algorithm that protects sender reputation by performing over 240 independent, real-time scans analyzing your data for all known problematic or non-deliverable email addresses.

> 🚧 HTTP Headers
>
> The "content-type" in the HTTP header must be set to "application/json", otherwise an HTTP 400 Bad Request response will be returned.

## Response Definitions

A single response may include multiple Email addresses. A match level is returned for each email address to indicate the context in which the match was made.

| Field name | Type   | Description                                                                                                                      |
| :--------- | :----- | :------------------------------------------------------------------------------------------------------------------------------- |
| Email      | string | Fully verified email address                                                                                                     |
| FirstName  | string | Listing identity's first name                                                                                                    |
| LastName   | string | Listing identity's last name                                                                                                     |
| MatchLevel | string | Indicates the \[MatchLevel] (<https://docs.accurateappend.com/reference/matchlevel-consumer-1>) under which the match was found. |

## MatchLevel

The MatchLevel response field indicates how well the request fields sent to the API match the response fields. For example, a MatchLevel returned of E1 might be considered an exact match whereas a return of E2 reveals that the first name of the individual does not necessarily match the request fields. [Click to see the MatchLevel codes and descriptions](https://docs.accurateappend.com/reference/matchlevel-consumer-1).

## HTTP Error Messages

[Click to see a complete listing of error messages and codes](https://docs.accurateappend.com/reference#error-messages).

# OpenAPI definition

```json
{
  "openapi": "3.1.0",
  "info": {
    "title": "new-api-settings",
    "version": "2"
  },
  "servers": [
    {
      "url": "https://api.accurateappend.com/Services/V2"
    }
  ],
  "security": [
    {}
  ],
  "paths": {
    "/AppendEmail/{licensekey}/": {
      "get": {
        "summary": "MaxConnect Email Append",
        "description": "Append verified email addresses to U.S. contact records by searching our database of more than 1.8 billion listings using existing contact fields such as first name, last name, city, state, and postal address.",
        "operationId": "appendemail",
        "parameters": [
          {
            "name": "licensekey",
            "in": "path",
            "description": "License key issued by customer support. <a href=\"https://clients.accurateappend.com/Api/Trial/RequestTrial\" target=\"_blank\" >Click here</a> for a trial key",
            "required": true,
            "schema": {
              "type": "string",
              "default": "Default"
            }
          },
          {
            "name": "firstname",
            "in": "query",
            "description": "Search subject's first name. Optional, if lastname is passed in the request.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "lastname",
            "in": "query",
            "description": "Search subject's last name. Full name can be passed into the lastname field. Our system will parse the contents of the field into first and last name for the purposes of the append.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "address",
            "in": "query",
            "description": "Search subject's address. Currently only US postal addresses are accepted. Addresses are parsed and corrected by our system using CASS software prior to matching.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "city",
            "in": "query",
            "description": "City associated with search subject's address.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "state",
            "in": "query",
            "description": "State associated with search subject's address.",
            "required": true,
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "postalcode",
            "in": "query",
            "description": "Postal code associated with search subject's address.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "matchlevel",
            "in": "query",
            "description": "Semi-colon delimited list of MatchLevel used to filter response. If omitted, the match levels E1;E2;N1;N2;B1;B2 will. be assumed.",
            "schema": {
              "type": "string"
            }
          },
          {
            "name": "verifyDeliverableEmail",
            "in": "query",
            "description": "Output email addresses can be verified in real-time by pinging the ISP to determine deliverability status with 90% accuracy. Output email addresses are also scanned by a real-time SPAM detection algorithm that protects sender reputation by performing over 240 independent, real-time scans analyzing your data for all known problematic or non-deliverable email addresses.",
            "schema": {
              "type": "boolean"
            }
          },
          {
            "name": "maxResults",
            "in": "query",
            "description": "Sets the maximum number of results to return. Value 1-5.",
            "schema": {
              "type": "integer",
              "format": "int32"
            }
          },
          {
            "name": "suppression",
            "in": "query",
            "description": "Semi-colon delimited list containing up to 5 email addresses to be suppressed from query and results. .",
            "schema": {
              "type": "string"
            }
          }
        ],
        "responses": {
          "200": {
            "description": "200",
            "content": {
              "application/json": {
                "examples": {
                  "Result": {
                    "value": "{  \n   \"Criteria\":{  \n      \"Host\":\"XXXX\",\n      \"RequestDate\":\"2015-07-14T15:31:51.3449564Z\",\n      \"RequestIP\":\"192:168:1:1\",\n      \"TransactionId\":\"e5be8f0e-a6ee-46b0-bd9b-e2450efbb70e\",\n      \"Address\":\"123 Main St\",\n      \"City\":\"Seattle\",\n      \"FirstName\":\"John\",\n      \"LastName\":\"Smith\",\n      \"PostalCode\":\"98101\",\n      \"State\":\"WA\",\n      \"MatchLevels\":\"E1;E2;N1;N2\"\n   },\n   \"Emails\":[  \n      {  \n         \"Email\":\"JOHN.SMITH@YAHOO.COM\",\n         \"FirstName\":\"JOHN\",\n         \"LastName\":\"SMITH\",\n         \"MatchLevel\":\"E1\"\n      }\n   ]\n}"
                  }
                },
                "schema": {
                  "type": "object",
                  "properties": {
                    "Criteria": {
                      "type": "object",
                      "properties": {
                        "Host": {
                          "type": "string",
                          "example": "XXXX"
                        },
                        "RequestDate": {
                          "type": "string",
                          "example": "2015-07-14T15:31:51.3449564Z"
                        },
                        "RequestIP": {
                          "type": "string",
                          "example": "192:168:1:1"
                        },
                        "TransactionId": {
                          "type": "string",
                          "example": "e5be8f0e-a6ee-46b0-bd9b-e2450efbb70e"
                        },
                        "Address": {
                          "type": "string",
                          "example": "123 Main St"
                        },
                        "City": {
                          "type": "string",
                          "example": "Seattle"
                        },
                        "FirstName": {
                          "type": "string",
                          "example": "John"
                        },
                        "LastName": {
                          "type": "string",
                          "example": "Smith"
                        },
                        "PostalCode": {
                          "type": "string",
                          "example": "98101"
                        },
                        "State": {
                          "type": "string",
                          "example": "WA"
                        },
                        "MatchLevels": {
                          "type": "string",
                          "example": "E1;E2;N1;N2"
                        }
                      }
                    },
                    "Emails": {
                      "type": "array",
                      "items": {
                        "type": "object",
                        "properties": {
                          "Email": {
                            "type": "string",
                            "example": "JOHN.SMITH@YAHOO.COM"
                          },
                          "FirstName": {
                            "type": "string",
                            "example": "JOHN"
                          },
                          "LastName": {
                            "type": "string",
                            "example": "SMITH"
                          },
                          "MatchLevel": {
                            "type": "string",
                            "example": "E1"
                          }
                        }
                      }
                    }
                  }
                }
              }
            }
          },
          "400": {
            "description": "400",
            "content": {
              "application/json": {
                "examples": {
                  "Bad Request - Invalid Match Level": {
                    "value": "{ \"Error\": \"An invalid match level was entered\" }"
                  },
                  "Bad Request - Missing parameters": {
                    "value": "{ \"Error\": \"First name, last name, address, city, state and match level is required\" }"
                  }
                },
                "schema": {
                  "oneOf": [
                    {
                      "title": "Bad Request - Invalid Match Level",
                      "type": "object",
                      "properties": {
                        "Error": {
                          "type": "string",
                          "example": "An invalid match level was entered"
                        }
                      }
                    },
                    {
                      "title": "Bad Request - Missing parameters",
                      "type": "object",
                      "properties": {
                        "Error": {
                          "type": "string",
                          "example": "First name, last name, address, city, state and match level is required"
                        }
                      }
                    }
                  ]
                }
              }
            }
          },
          "401": {
            "description": "401",
            "content": {
              "application/json": {
                "examples": {
                  "Result": {
                    "value": "{ \"Error\": \"License key is required\" }"
                  }
                },
                "schema": {
                  "type": "object",
                  "properties": {
                    "Error": {
                      "type": "string",
                      "example": "License key is required"
                    }
                  }
                }
              }
            }
          },
          "500": {
            "description": "500",
            "content": {
              "application/json": {
                "examples": {
                  "Result": {
                    "value": "{ \"Error\": \"An error has occurred. The system administrator has been contacted\" }"
                  }
                },
                "schema": {
                  "type": "object",
                  "properties": {
                    "Error": {
                      "type": "string",
                      "example": "An error has occurred. The system administrator has been contacted"
                    }
                  }
                }
              }
            }
          }
        },
        "x-readme": {
          "code-samples": [
            {
              "language": "php",
              "code": "<?php\n\n$licensekey = \"YOURKEYHERE\";\n\n$url =  \"https://api.accurateappend.com/Services/V2/AppendEmail/\" . $licensekey . \"/?\";\n$querystring = \"firstname=john\" .\n               \"&lastname=smith\" .\n               \"&address=\" . urlencode(\"123 main st\") .\n               \"&city=seattle\" .\n               \"&state=wa\" .\n               \"&postalcode=98101\" .\n               \"&matchlevel=E1;E2;N1;N2\";\n\n$url .= $querystring;\n//echo \"request url: \" . $url . \"<br>\\n<br>\\n\";\n\nif(strtoupper(substr(PHP_OS, 0, 3)) === 'WIN')\n{\n    // windows operating system as the requesting server\n    $cacert_path_file = dirname(__FILE__) . \"\\cacert.pem\";\n}\nelse\n{\n    // other os\n    $cacert_path_file = \"cacert.pem\";\n}\n\n$ch = curl_init();\ncurl_setopt($ch, CURLOPT_URL, $url);\ncurl_setopt($ch, CURLOPT_HTTPGET, true);\ncurl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: application/json'));\ncurl_setopt($ch, CURLOPT_SSLVERSION, 'CURL_SSLVERSION_DEFAULT');  // on a windows server the single quotes are required on 3rd parameter\ncurl_setopt($ch, CURLOPT_CAINFO, $cacert_path_file);\ncurl_setopt($ch, CURLOPT_RETURNTRANSFER, true);\ncurl_setopt($ch, CURLOPT_VERBOSE, true);\n\n$json_string = curl_exec($ch);\n$curl_err = curl_error($ch);\n\nif($curl_err)\n{\n    echo \"curl error: $curl_err\";\n}\nelse\n{\n    curl_close($ch);\n\n    // decode json\n    $parsed_json = json_decode($json_string);\n\n    // instantiate an associative array\n    $response = array();\n    // load json data into associative array\n    $response = json_to_associative($parsed_json);\n\n    // print the associative array to the screen\n    foreach ($response as $key => $value)\n    {\n        echo $key . \" = \" . $value . \"<br>\\n\";\n    }\n}\n\n\n\n// --------------------------------------------------------- //\n//\n// --------------------------------------------------------- //\nfunction json_to_associative($parsed_json)\n{\n    $response = array();\n\n    // load the associative array with all response key/value pairs\n    $response['Host'] = $parsed_json->{'Criteria'}->Host;\n    $response['RequestDate'] = $parsed_json->{'Criteria'}->RequestDate;\n    $response['RequestIP'] = $parsed_json->{'Criteria'}->RequestIP;\n    $response['TransactionId'] = $parsed_json->{'Criteria'}->TransactionId;\n    $response['Address'] = $parsed_json->{'Criteria'}->Address;\n    $response['City'] = $parsed_json->{'Criteria'}->City;\n    $response['FirstName'] = $parsed_json->{'Criteria'}->FirstName;\n    $response['LastName'] = $parsed_json->{'Criteria'}->LastName;\n    $response['PostalCode'] = $parsed_json->{'Criteria'}->PostalCode;\n    $response['State'] = $parsed_json->{'Criteria'}->State;\n\n\n    // typecast the stdClass to array\n    $obj_arr = (array)$parsed_json->{'Emails'};\n\n    if(!empty($obj_arr))\n    {\n        // iteration required for mulitple Emails response\n        for($i = 0; $i < count($parsed_json->{'Emails'}); $i++)\n        {\n            $keynum = $i + 1;\n            $response['Email_' . $keynum] = $parsed_json->{'Emails'}[$i]->Email;\n            $response['MatchLevel_' . $keynum] = $parsed_json->{'Emails'}[$i]->MatchLevel;\n        }\n    }\n    return $response;\n}\n\n?>\n\n/*\nCopyright (c) 2015-2025, AccurateAppend Corp\nAll rights reserved.\n\nRedistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:\n\n1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.\n\n2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.\n\n3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.\n\nTHIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS \"AS IS\" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF \nADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n*/"
            },
            {
              "language": "csharp",
              "code": "using System;\nusing System.Collections.Generic;\nusing System.Net;\nusing RestSharp;\n\nnamespace Samples\n{\n    // This example uses the RestSharp NuGet package (https://www.nuget.org/packages/RestSharp)\n  \n    public static class Program\n    {\n        private const String Key = \"YOURKEYHERE\";\n        private const String RootUri = @\"http://api.accurateappend.com/Services/V2\";\n\n        public static void Main(String[] args)\n        {\n            EmailAppend();\n        }\n\n        #region Email Append\n\n        private static void EmailAppend()\n        {\n            const String Resource =\n                \"/AppendEmail/\" + Key +\n                \"/?firstname=john&lastname=smith&address=123 main st&city=seattle&state=wa&postalcode=98101&matchlevel=E1;E2;N1;N2\";\n\n            var request = new RestRequest(Resource) {Method = Method.GET};\n\n            var client = new RestClient(RootUri);\n            var response = client.Execute<EmailResult>(request);\n            if (response.StatusCode != HttpStatusCode.OK)\n            {\n                // Error Handling Omitted For Brevity\n            }\n            var data = response.Data;\n            foreach (var item in data.Emails)\n            {\n                Console.WriteLine(\"Email:{0}\", item.Email);\n            }\n        }\n\n        public class EmailResult\n        {\n            public List<EmailItem> Emails { get; set; }\n        }\n\n        public class EmailItem\n        {\n            public String Email { get; set; }\n\n            public String FirstName { get; set; }\n\n            public String LastName { get; set; }\n\n            public String MatchLevel { get; set; }\n        }\n\n        #endregion\n    }\n}\n\n/*\nCopyright (c) 2015-2025, AccurateAppend Corp\nAll rights reserved.\n\nRedistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:\n\n1. Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.\n\n2. Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.\n\n3. Neither the name of the copyright holder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission.\n\nTHIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS \"AS IS\" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF \nADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n*/"
            }
          ],
          "samples-languages": [
            "php",
            "csharp"
          ]
        }
      }
    }
  },
  "x-readme": {
    "headers": [],
    "explorer-enabled": true,
    "proxy-enabled": true
  },
  "x-readme-fauxas": true
}
```